!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!module to precompute the probabilty distribution needed for the quadratic correlation  !!
!function!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!D. Meerburg 2014!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


module probabilty

use settings
use correlation
use background 

implicit none

real(mcp), public :: propUxU0(NuX,Nu0,Nx)
integer, public :: NxMax, NxMin


	contains 	
	
	
	
	subroutine compute_CorProb
	
	integer :: i,j,n,intk,intl
	integer :: intkmax = 10, intlmax = 10
	real(mcp) :: upar0, uparX, uper0, uperX 
	real(mcp) :: muX, mu0
	real(mcp) :: u0, uX
	real(mcp) :: DelmuX, Delmu0
	real(mcp) :: tempF, tempP, tempB
	
	DelmuX = 2.d0/intkmax
	Delmu0 = 2.d0/intlmax
	
	do i = 1, NuX
#ifdef MPI
	if (omp%rank .eq. my_mpi_root) write(*,*) "outer loop"
#else
	write(*,*) "outer loop"
#endif
	uX  = NuXtab(i)
		do j = 1, Nu0
		u0  = Nu0tab(j)
			do n = NxMin, NxMax			
			!if (omp%rank .eq. my_mpi_root) write(*,*) cperptab(n), cparatab(n)
			tempP = u0**2*uX**2/(2.d0*pi*sqrt(1-cparatab(n)**2)*(1-cperptab(n)**2))
			
			muX = -1.d0
			!performing integral over muX and mu0
			do intk = 1, intkmax+1
				mu0 = -1.d0				
				uparX = uX*muX
				uperX = uX*sqrt(1.d0-muX**2)
				do intl = 1, intlmax+1
				upar0 = u0*mu0
				uper0 = u0*sqrt(1.d0-mu0**2)


				tempF = -(1.d0/2.d0)*(upar0**2+uparX**2-2.d0*cparatab(n)*upar0*uparX)/(1.d0-cparatab(n)) &
						-(1.d0/2.d0)*(upar0**2+uper0**2)/(1-cperptab(n))
				tempB = cperptab(n)*uper0*uperX/(1.0d0-cperptab(n)**2)
				!if (omp%rank .eq. my_mpi_root) write(*,*) uper0, uperX, muX
				propUxU0(i,j,n) = exp(tempF)*Delmu0*DelmuX 
				
				mu0 = mu0+Delmu0
				enddo
			    !write(*,*) tempB
			    muX = muX+DelmuX
				
			enddo
			propUxU0(i,j,n) = tempP*propUxU0(i,j,n)
			enddo 
		enddo 
		 write(*,*) tempB
	enddo 
	
	
	end subroutine compute_CorProb
	
	subroutine det_NxMinNxMax
	!this will depend on cosmology, so hence this automization
	real(mcp) :: cbar 
	real(mcp) :: sumc2
	integer :: i
	
	
	do i = 1, Nx	
		cbar = (1.d0/3.d0)*cparatab(i)+(2.d0/3.d0)*cperptab(i)
		if (1.d0 -cbar .ge. 0.03d0) then
			NxMin = i
			!write(*,*) "Nxmin:", NxMin
			exit
		endif
	enddo
	!can improve speed by inverting loop:
	do i = 1, Nx	
		sumc2 = cparatab(i)**2+cperptab(i)**2
		if (sumc2 .le. 0.0001d0) then
			NxMax = i
			!write(*,*) "Nxmax:", NxMax
			exit
		endif
	enddo
	
	end subroutine det_NxMinNxMax
	
end module probabilty 