!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!Various settings and Type defenitions!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!D. Meerburg 2014!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


module settings


implicit none

	integer, parameter :: mcp= KIND(1.d0)
    !allocation = #redshift*#k*#vbc = 100*50*45 = 225000
    integer, parameter :: Nvbc = 45
    integer, parameter :: Nk = 50 
    integer, parameter :: Na = 100
    !integer, parameter :: Ntrans = 423
	integer, parameter :: zkvmax = Nvbc*Nk*Na
	
	integer, parameter :: Nkl = 200
	
	integer, parameter :: numc = 5
	
	integer, parameter :: feedback = 0
	
	integer, parameter :: xezmax = 1031
	integer, parameter :: aimax = 4000
	!small scales
	real(mcp), parameter :: kmax = 2700.
	real(mcp), parameter :: kmin = 10.
	real(mcp), parameter :: Dlogk = Log(kmax/kmin)/(Nk-1)
	!large scales
	real(mcp), parameter :: klmin = 0.0001
	real(mcp), parameter :: klmax = 1.0d0
	
	real(mcp), parameter :: trmin = 0.004
    real(mcp), parameter :: trmax = 0.4
    
    integer, parameter :: ntr = 100
    real(mcp), parameter :: tMovtrmin = 0.1
    real(mcp), parameter :: tMovtrmax = 1.
    integer, parameter :: ntm = 40
    
    integer, parameter :: my_mpi_root=0
    
    !scale factor 
    
    real(mcp), parameter :: ainit = 1.d0/1011.d0
    real(mcp), parameter :: aend = 1.d0/21.d0
    
    !vbc
    real(mcp), parameter :: vbcmax  = 90.d0
    
    real(mcp), parameter :: pi = 3.14159265358979323846264338328d0
    
    real(mcp), parameter :: GNewton = 6.67385E-5 !cm^3 kg^-1s^-2
    real(mcp), parameter :: clight  = 299792458.d0 !m/s
    real(mcp), parameter :: kBoltzmann = 1.3806488E-19 !cm^2 kg/s^2/K
    !real space
    
    real(mcp), parameter :: xmin = 0.d0     
	real(mcp), parameter :: xint = 10.d0
	integer, parameter :: Nxlo = 200
	real(mcp), parameter :: xmax = 1000.d0
	integer, parameter :: Nxhi = 300
	integer, parameter :: Nx = Nxlo + Nxhi - 1
	!for now
	integer, parameter :: Nu0 = 100
	integer, parameter :: NuX = 100
	
	!switches
	logical :: xeCAMB = .true. !use xe, tm directly from CAMB
	logical :: Compute_Tgas = .false. !compute Tgas instead of reading it from file
    
	Type fluctuations
		real(mcp) :: bar(zkvmax,numc)
		real(mcp) :: vbar(zkvmax,numc)
		real(mcp) :: Tgas(zkvmax,numc)
		real(mcp) :: xe(zkvmax,numc)
		real(mcp) :: cdm(zkvmax,numc)
		real(mcp) :: vcdm(zkvmax,numc)
	end Type fluctuations
	
	Type pert
		real(mcp) :: Rebar(Na,Nvbc,Nk)
		real(mcp) :: Revbar(Na,Nvbc,Nk)
		real(mcp) :: ReTgas(Na,Nvbc,Nk)
		real(mcp) :: Rexe(Na,Nvbc,Nk)
		real(mcp) :: Recdm(Na,Nvbc,Nk)
		real(mcp) :: Revcdm(Na,Nvbc,Nk)
		real(mcp) :: Imbar(Na,Nvbc,Nk)
		real(mcp) :: Imvbar(Na,Nvbc,Nk)
		real(mcp) :: ImTgas(Na,Nvbc,Nk)
		real(mcp) :: Imxe(Na,Nvbc,Nk)
		real(mcp) :: Imcdm(Na,Nvbc,Nk)
		real(mcp) :: Imvcdm(Na,Nvbc,Nk)
	end Type pert

	
	Type cosmopar
		 real(mcp) h0
		 real(mcp) omegab0
		 real(mcp) omegac0 
		 real(mcp) Tcmb0
		 real(mcp) YHe 
		 real(mcp) Neff 
		 real(mcp) As 
		 real(mcp) ns
		 real(mcp) kpivot
		 real(mcp) fb
	end Type cosmopar
	
	Type derived
		 real(mcp) omegar0
		 real(mcp) omegaL0
		 real(mcp) mHemH
		 real(mcp) fHe 
		 real(mcp) Hub0
		 real(mcp) mu 
		 real(mcp) nh0 
		 real(mcp) kmpermpc
		 real(mcp) omegamh2
		 real(mcp) bone
		 real(mcp) btwo
		 real(mcp) zd
	end Type derived
	
	
	Type otherp
	
		real(mcp) kb
		real(mcp) EI
		real(mcp) L2s
		real(mcp) SahaCoef
		real(mcp) sigmav_over_mchi
		real(mcp) HydIoE
		real(mcp) EvToKg
		real(mcp) HydIoEinKg
		real(mcp) sigmav_over_mchiSI
		logical :: DMAN_on !logical to turn on DM anihilation
	
	end Type otherp
	
	
	Type InitialC
	
		real(mcp) :: deltab(Nk)
		real(mcp) :: deltac(Nk)
		real(mcp) :: deltavb(Nk)
		real(mcp) :: deltavc(Nk)
		
	end Type InitialC
	
end module settings




